import sqlite3
import sys
import time

### Fill in details <<<---
shipName = 'Hydra SRM Orbital "King Cobra"'
weaponName = 'SRM Hydra Missile Launcher (1/0.6-75r)'
fcName = 'Hydra Missile Turret r.18.9m-res250-50t'
missileName = '"Dragonfly" SRM'				# obviously ignore if just assigning beam weapons

### Begin
sqliteConnection = sqlite3.connect('AuroraDB.db')
cursor = sqliteConnection.cursor()

## Error checking and ID collection
# ShipID
sql_command = """SELECT * FROM FCT_Ship WHERE ShipName='%s'""" % (shipName)
cursor.execute(sql_command)
ans = cursor.fetchall()
if not ans:
	sys.exit('Ship does not exist')
else:
	ship_id = ans[0][0]
	class_id = ans[0][33]
	game_id = ans[0][1]
# WeaponID
cursor.execute("""SELECT * FROM FCT_ShipDesignComponents WHERE Name='%s'""" % (weaponName))
ans = cursor.fetchall()
if not ans:
	sys.exit('Weapon does not exist')
else:
	weapon_id = ans[0][0]
	if ans[0][10] == 22:
		missileLauncher = True
	else:
		missileLauncher = False
# FCTypeID
cursor.execute("""SELECT * FROM FCT_ShipDesignComponents WHERE Name='%s'""" % (fcName))
ans = cursor.fetchall()
if not ans:
	sys.exit('Fire Control does not exist')
else:
	fc_type_id = ans[0][0]
# MissileID
if missileLauncher:
	cursor.execute("""SELECT * FROM FCT_Missiles WHERE Name='%s'""" % (missileName))
	ans = cursor.fetchall()
	if not ans:
		sys.exit('Fire Control does not exist')
	else:
		missile_id = ans[0][0]
# Number of Fire Controls
cursor.execute("""SELECT * FROM FCT_ClassComponent WHERE ClassID=%i AND ComponentID=%i""" % (class_id, fc_type_id))
ans = cursor.fetchall()
fccountmax = int(ans[0][3])
# Total Weapon Count
cursor.execute("""SELECT * FROM FCT_ClassComponent WHERE ClassID=%i AND ComponentID=%i""" % (class_id, weapon_id))
ans = cursor.fetchall()
totalwpncount = int(ans[0][3])
fcwpncountmax = int((totalwpncount - (totalwpncount % fccountmax)) / fccountmax)

## DB writing
fccount = 1
fcwpncount = 1
wpncount = 1

while fccount <= fccountmax:
	while fcwpncount <= fcwpncountmax:
		# clear all old weapon assignments
		sql_command = """DELETE FROM FCT_WeaponAssignment WHERE ShipID=%i AND WeaponNum=%i""" % (ship_id, wpncount)
		cursor.execute(sql_command)
		if missileLauncher:
			sql_command = """DELETE FROM FCT_MissileAssignment WHERE ShipID=%i AND WeaponNum=%i""" % (ship_id, wpncount)
			cursor.execute(sql_command)

		# rewire fire controls
		sql_command = """INSERT INTO FCT_WeaponAssignment (ShipID, WeaponID, WeaponNum, FCTypeID, FCNum, GameID)
			VALUES (%i, %i, %i, %i, %i, %i);""" % (ship_id, weapon_id, wpncount, fc_type_id, fccount, game_id)
		cursor.execute(sql_command)
		if missileLauncher:
			sql_command = """INSERT INTO FCT_MissileAssignment (ShipID, MissileID, WeaponID, WeaponNum, GameID)
				VALUES (%i, %i, %i, %i, %i);""" % (ship_id, missile_id, weapon_id, wpncount, game_id)
			cursor.execute(sql_command)

		fcwpncount += 1
		wpncount += 1

	fccount = fccount + 1
	fcwpncount = 1

sqliteConnection.commit()
sqliteConnection.close()

print('Assignment complete!')
time.sleep(2)